#include <bits/extc++.h>
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sfor(i, l, r) for (int i = l; i <= r; ++i)
#define bfor(i, r, l) for (int i = r; i >= l; --i)
#define range(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int INF = 1e9 + 10;
int n;
vector<vi> on, lev, g;
vector<bool> used;
vi s, prf;

void TopSort(int u) {
    used[u] = true;
    for (auto v: g[u]) {
        if (!used[v])
            TopSort(v);
    }
    s.push_back(u);
}

int Solve() {
    g.assign(n, vi(0));
    sfor(l, 0, (int)lev.size() - 1) {
        sfor(i, 1, (int)lev[l].size() - 1) g[lev[l][i - 1]].push_back(lev[l][i]);
    }
    sfor(l, 0, (int)lev.size() - 2) {
        int j = 0;
        for (auto u: lev[l]) {
            sfor(i, 0, (int)on[u].size() - 2) g[on[u][i]].push_back(u);
            if (j + 1 < lev[l].size())
                g[u].push_back(on[u].back());
            ++j;
        }
    }
    used.assign(n, false);
    sfor(i, 0, n - 1) {
        if (!used[i])
            TopSort(i);
    }
    reverse(range(s));
    vi dp(n, 1);
    int mx = 1;
    for (auto u: s) {
        for (auto v: g[u])
            dp[v] = max(dp[v], dp[u] + 1);
        mx = max(mx, dp[u]);
    }
    prf.resize(n);
    sfor(l, 0, (int)lev.size() - 1) {
        for (auto u: lev[l])
            prf[u] = dp[u];
        prf[lev[l].back()] = mx;
    }
    return mx;
}

int main() {
    fast;
    int m;
    cin >> n >> m;
    on.resize(n);
    vi und(n, 0);
    sfor(i, 0, m - 1) {
        int u, d;
        cin >> u >> d;
        on[u - 1].push_back(d - 1);
        ++und[d - 1];
    }
    int t;
    cin >> t;
    vi dist(n, INF);
    queue<int> q;
    sfor(i, 0, n - 1) {
        if (und[i] == 0) {
            dist[i] = 0;
            q.push(i);
        }
    }
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        if (dist[u] >= lev.size())
            lev.emplace_back();
        lev.back().push_back(u);
        for (auto v: on[u]) {
            if (dist[u] + 1 < dist[v]) {
                dist[v] = dist[u] + 1;
                q.push(v);
            }
        }
    }
    if (t == 1) {
        sfor(l, 0, (int)lev.size() - 1) sort(range(lev[l]));
        sfor(i, 0, n - 1) sort(range(on[i]));
        Solve();
        cout << lev.size() << ' ' << Solve() << '\n';
        sfor(l, 0, (int)lev.size() - 1) {
            cout << lev[l].size() << ' ';
            int last = 0;
            for (auto u: lev[l]) {
                cout << u + 1 << ' ' << prf[u] - last << ' ';
                last = prf[u];
            }
            cout << '\n';
        }
    }
}
