#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#define x first
#define y second
#define all(v) v.begin(), v.end()
#define chkmin(a, b) a = min(a, b)
#define chkmax(a, b) a = max(a, b)
using namespace std;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef pair<int, int> pii;
typedef vector<pii> vii;

const int MAX_N = 2e5 + 1;
const int infinity = 1e9;

vi level[MAX_N];

void Dfs(vector<set<int>> &graph, int node, int d, vb &visited)  {
    visited[node] = true;
    level[d].push_back(node);
    for (int neighbor : graph[node]) {
        if (!visited[neighbor]) Dfs(graph, neighbor, d + 1, visited);
    }
}

vi ans;
int a;

void Solve(vi &last, int d, vector<set<int>> &graph) {
    if (d == -1) {
        if (ans.size() > last.size()) {
            ans = last;
        }
        return;
    }
    sort(all(level[d]));
    do {
        int ind = 0;
        vi curr;
        bool good = true;
        int j = -1;
        for (int i : level[d]) {
            int cnt = graph[i].size();
            if (ind && graph[i].count(last[ind - 1])) {
                if (ind == last.size() || last[ind] != last[ind - 1]) {
                    curr.push_back(i);
                    cnt--;
                }
            }
            if (ind < last.size() && !graph[i].count(last[ind])) {
                if (!ind || last[ind - 1] != last[ind]) {
                    good = false;
                    break;
                }
                while (ind < last.size() && last[ind] == last[ind - 1]) {
                    curr.push_back(j);
                    ind++;
                }
            }
            while (cnt--) {
                if (ind == last.size() || !graph[i].count(last[ind])) {
                    good = false;
                    break;
                }
                int x = last[ind];
                if (cnt) {
                    while (ind < last.size() && last[ind] == x) {
                        curr.push_back(i);
                        ind++;
                    }
                } else {
                    curr.push_back(i);
                    ind++;
                }
            }
            j = i;
            if (!good) break;
        }
        if (good) Solve(curr, d - 1, graph);
    } while (next_permutation(all(level[d])));
}

vvi answer;

bool Ans(vi &last, int d, vector<set<int>> &graph) {
    if (level[d].empty()) {
        while (last.size() < a) last.push_back(last.back());
        answer.push_back(last);
        return true;
    }
    sort(all(level[d]));
    do {
        int ind = 0;
        vi curr;
        bool good = true;
        int j = -1;
        for (int i : level[d]) {
            int cnt = graph[i].size();
            if (ind && graph[i].count(last[ind - 1])) {
                if (ind == last.size() || last[ind] != last[ind - 1]) {
                    curr.push_back(i);
                    last.insert(last.begin() + ind, last[ind - 1]);
                    ind++;
                    cnt--;
                }
            }
            if (ind < last.size() && !graph[i].count(last[ind])) {
                if (!ind || last[ind - 1] != last[ind]) {
                    good = false;
                    break;
                }
                while (ind < last.size() && last[ind] == last[ind - 1]) {
                    curr.push_back(j);
                    ind++;
                }
            }
            while (cnt--) {
                if (ind == last.size() || !graph[i].count(last[ind])) {
                    good = false;
                    break;
                }
                int x = last[ind];
                if (cnt) {
                    while (ind < last.size() && last[ind] == x) {
                        curr.push_back(i);
                        ind++;
                    }
                } else {
                    curr.push_back(i);
                    ind++;
                }
            }
            j = i;
            if (!good) break;
        }
        if (good) {
            while (last.size() < a) last.push_back(last.back());
            if (Ans(curr, d + 1, graph)) {
                answer.push_back(last);
                return true;
            }
        }
    } while (next_permutation(all(level[d])));
    return false;
}


int main() {
    int n, m;
    cin >> n >> m;
    vi deg(n + 1);
    vector<set<int>> graph(n + 1);
    vector<set<int>> invert_graph(n + 1);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        graph[a].insert(b);
        invert_graph[b].insert(a);
        deg[b]++;
    }
    vb visited(n + 1);
    for (int i = 1; i <= n; i++) {
        if (!deg[i]) Dfs(graph, i, 0, visited);
    }
    ans.resize(n + 1);
    for (int i = n - 1; i >= 0; i--) {
        if (!level[i].empty()) {
            sort(all(level[i]));
            do {
                Solve(level[i], i - 1, graph);
            } while (next_permutation(all(level[i])));
            break;
        }
    }
    a = ans.size();
    Ans(ans, 1, invert_graph);
    reverse(all(answer));
    cout << answer.size() << ' ' << a << '\n';
    for (vi &v : answer) {
        int sz = v.size();
        int ind = v[0], cnt = 1;
        vii p;
        for (int i = 1; i < sz; i++, cnt++) {
            if (v[i] != ind) {
                p.push_back({ind, cnt});
                ind = v[i], cnt = 0;
            }
        }
        p.push_back({ind, cnt});
        cout << p.size() << ' ';
        for (pii q : p) cout << q.x << ' ' << q.y << ' ';
        cout << '\n';
    }
//    cout << ans;
}
