#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#define x first
#define y second
#define all(v) v.begin(), v.end()
#define chkmin(a, b) a = min(a, b)
#define chkmax(a, b) a = max(a, b)
using namespace std;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef pair<int, int> pii;
typedef vector<pii> vii;

const int MAX_N = 2e5 + 1;
const int infinity = 1e9;

vi level[MAX_N];

void Dfs(vector<set<int>> &graph, int node, int d, vb &visited)  {
    visited[node] = true;
    level[d].push_back(node);
    for (int neighbor : graph[node]) {
        if (!visited[neighbor]) Dfs(graph, neighbor, d + 1, visited);
    }
}

vvi ans;
int a;

void Solve(vvi walls, int d, vector<set<int>> &graph) {
    if (d == -1) {
        if (ans.back().size() > walls.back().size()) {
            ans = walls;
        }
        return;
    }
    sort(all(level[d]));
    do {
        if (level[d] == vi{8, 4, 2, 7, 10}) {
            cout << "";
        }
        int ind = 0;
        vvi last = walls;
        vi curr;
        bool good = true;
        int j = -1;
        for (int i : level[d]) {
            int cnt = graph[i].size();
            if (ind && graph[i].count(last.back()[ind - 1])) {
                if (ind == last.back().size() || last.back()[ind] != last.back()[ind - 1]) {
                    for (vi &v : last) {
                        v.insert(v.begin() + ind - 1, v[ind - 1]);
                    }
                    curr.push_back(i);
                    ind++;
                    cnt--;
                }
            }
            if (ind < last.back().size() && !graph[i].count(last.back()[ind])) {
                if (!ind || last.back()[ind - 1] != last.back()[ind]) {
                    good = false;
                    break;
                }
                while (ind < last.back().size() && last.back()[ind] == last.back()[ind - 1]) {
                    curr.push_back(j);
                    ind++;
                }
            }
            while (cnt--) {
                if (ind == last.back().size() || !graph[i].count(last.back()[ind])) {
                    good = false;
                    break;
                }
                int x = last.back()[ind];
                if (cnt) {
                    while (ind < last.back().size() && last.back()[ind] == x) {
                        curr.push_back(i);
                        ind++;
                    }
                } else {
                    curr.push_back(i);
                    ind++;
                }
            }
            j = i;
            if (!good) break;
        }
        if (good) {
            last.push_back(curr);
            Solve(last, d - 1, graph);
        }
    } while (next_permutation(all(level[d])));
}

int main() {
    int n, m;
    cin >> n >> m;
    vi deg(n + 1);
    vector<set<int>> graph(n + 1);
    vector<set<int>> invert_graph(n + 1);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        graph[a].insert(b);
        invert_graph[b].insert(a);
        deg[b]++;
    }
    ans = {vi(n + 1)};
    vb visited(n + 1);
    for (int i = 1; i <= n; i++) {
        if (!deg[i]) Dfs(graph, i, 0, visited);
    }
    for (int i = n - 1; i >= 0; i--) {
        if (!level[i].empty()) {
            sort(all(level[i]));
            do {
                vvi v = {level[i]};
                Solve(v, i - 1, graph);
            } while (next_permutation(all(level[i])));
            break;
        }
    }
    a = ans[0].size();
//    Ans(ans, 1, invert_graph);
    reverse(all(ans));
    cout << ans.size() << ' ' << a << '\n';
    for (vi &v : ans) {
        int sz = v.size();
        int ind = v[0], cnt = 1;
        vii p;
        for (int i = 1; i < sz; i++, cnt++) {
            if (v[i] != ind) {
                p.push_back({ind, cnt});
                ind = v[i], cnt = 0;
            }
        }
        p.push_back({ind, cnt});
        cout << p.size() << ' ';
        for (pii q : p) cout << q.x << ' ' << q.y << ' ';
        cout << '\n';
    }
//    cout << ans;
}
