﻿//#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

const int maxn = 2e5 + 5;
int lv[maxn];
vector<int> g[maxn], g2[maxn];
vector<int> l[maxn];
vector<int> g3[maxn];
int cnt[maxn];
bool used[maxn];
int pos_end[maxn];
vector<int> ord;

void dfs(int v) {
    used[v] = true;
    for (auto u : g3[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    ord.push_back(v);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, d;
        cin >> u >> d;
        u--, d--;
        g[u].push_back(d);
        g2[d].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        lv[i] = -1;
    }
    int t;
    cin >> t;
    if (!t) {
        return 1;
    }
    queue<int> q;
    for (int i = 0; i < n; ++i) {
        if (g2[i].empty()) {
            lv[i] = 0;
            q.push(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end());
        sort(g2[i].begin(), g2[i].end());
    }
    int h = 0, w = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        l[lv[v]].push_back(v);
        h = max(h, lv[v]);
        for (auto u : g[v]) {
            if (lv[u] == -1) {
                lv[u] = lv[v] + 1;
                q.push(u);
            }
        }
    }
    for (int i = 0; i < h; ++i) {
        sort(l[i].begin(), l[i].end());
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j + 1 < (int) l[i].size(); ++j) {
            g3[l[i][j]].push_back(l[i][j + 1]);
            cnt[l[i][j + 1]]++;
        }
    }
    for (int i = 0; i < n; ++i) {
        auto p1 = lower_bound(l[lv[i]].begin(), l[lv[i]].end(), i) - l[lv[i]].begin();
//        if (p1 + 1 < l[lv[i]].size()) {
//            g3[i].push_back(l[lv[i]][p1 + 1]);
//            cnt[l[lv[i]][p1 + 1]]++;
//        }
        for (int j = 0; j + 1 < (int) g[i].size(); ++j) {
            g3[g[i][j]].push_back(i);
            cnt[i]++;
        }
        if (p1 + 1 < l[lv[i]].size() && !g[i].empty()) {
            g3[i].push_back(g[i].back());
            cnt[g[i].back()]++;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i] && !cnt[i]) {
            pos_end[i] = 1;
            dfs(i);
        }
    }
    reverse(ord.begin(), ord.end());
    for (auto i : ord) {
//        cout << i << ' ';
        for (auto j : g3[i]) {
            pos_end[j] = max(pos_end[j], pos_end[i] + 1);
        }
    }
//    cout << '\n';
    for (int i = 0; !l[i].empty(); ++i) {
        h = i + 1;
        for (auto j : l[i]) {
            w = max(w, pos_end[j]);
        }
    }
    cout << h << ' ' << w << '\n';
    for (int i = 0; i < h; ++i) {
        cout << l[i].size() << ' ';
        for (int j = 0; j < (int) l[i].size(); ++j) {
            cout << l[i][j] + 1 << ' ';
            if (j == 0) {
                cout << pos_end[l[i][j]] << ' ';
            } else {
                if (j + 1 == (int) l[i].size()) {
                    pos_end[l[i][j]] = w;
                }
                cout << pos_end[l[i][j]] - pos_end[l[i][j - 1]] << ' ';
            }
        }
        cout << '\n';
    }
    return 0;
}

/*
11 14
1 4
1 5
2 5
3 5
3 6
3 7
3 8
4 9
5 9
5 10
6 10
6 11
7 11
8 11
1
 */