#include <iostream>
#include <vector>
#include <cassert>
#include <queue>
#include <algorithm>
#include <bitset>
using namespace std;

const int MAXN = 1e5 + 123;
vector<int> edg[MAXN];
vector<int> redg[MAXN];
int depth[MAXN];
vector<int> rdepth[MAXN];
int len[MAXN];
int addlen[MAXN];
bitset<MAXN> used;

signed main() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        edg[u].push_back(v);
    }
    for (int i = 0; i < n; ++i) {
        sort(edg[i].begin(), edg[i].end());
        for (auto u : edg[i])
            redg[u].push_back(i);
    }
    queue<int> q;
    for (int i = 0; i < n; ++i) {
        if (redg[i].empty()) {
            q.push(i);
        }
    }
    int mxdepth = 0;
    while (q.size()) {
        int v = q.front();
        rdepth[depth[v]].push_back(v);
        mxdepth = max(mxdepth, depth[v]);
        q.pop();
        for (auto u : edg[v]) {
            if (depth[u] == 0) {
                depth[u] = depth[v] + 1;
                q.push(u);
            }
        }
    }
    for (int d = mxdepth; d >= 0; --d) {
        if (d == mxdepth) {
            for (auto j : rdepth[d])
                len[j] = 1;
            continue;
        }
        int pj = -1;
        for (auto j : rdepth[d]) {
            for (auto u : edg[j]) {
                len[j] += len[u];
            }
            int u0 = edg[j][0];
            if (pj != -1 && u0 == edg[pj].back()) {
                len[j] -= len[u0];
                if (edg[pj].size() == 1) {
                    if (len[pj] == 1) {
                        ++len[j];
                        ++len[u0];
                        ++addlen[u0];
                    } else {
                        len[j] += len[pj] - 1;
                        len[pj] = 1;
                    }
                } else {
                    len[pj] -= len[u0] - 1;
                    len[j] += len[u0] - 1;
                }
            } else if (edg[j].size() == 1 && redg[u0].size() == 1) {
                assert(0);
            }
            pj = j;
        }
    }
    int h = mxdepth + 1;
    int w = 0;
    for (auto j : rdepth[0])
        w += len[j];
    cout << h << ' ' << w << endl;
    for (int d = 0; d <= mxdepth; ++d) {
        cout << rdepth[d].size() << ' ';
        for (auto j : rdepth[d]) {
            cout << j + 1 << ' ' << len[j] << ' ';
            if (addlen[j] > 0) {
                for (auto u : edg[j]) {
                    len[u] += addlen[j];
                    addlen[u] += addlen[j];
                }
            }
        }
        cout << endl;
    }
}
