#include <iostream>
#include <vector>
#include <cassert>
#include <queue>
#include <algorithm>
#include <bitset>
using namespace std;

const int MAXN = 1e5 + 123;
vector<pair<int, int>> edg[MAXN];
vector<int> redg[MAXN];
int depth[MAXN];
vector<int> rdepth[MAXN];
int len[MAXN];

int rt[MAXN];
int goodedg[MAXN];
bitset<MAXN> used;

signed main() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        edg[u].push_back({v, 1});
    }
    int T;
    cin >> T;
    assert(T);
    for (int i = 0; i < n; ++i) {
        sort(edg[i].begin(), edg[i].end());
        for (auto [u, t] : edg[i])
            redg[u].push_back(i);
    }
    queue<int> q;
    for (int i = 0; i < n; ++i) {
        if (redg[i].empty()) {
            q.push(i);
        }
    }
    int mxdepth = 0;
    while (q.size()) {
        int v = q.front();
        rdepth[depth[v]].push_back(v);
        mxdepth = max(mxdepth, depth[v]);
        q.pop();
        for (auto [u, t] : edg[v]) {
            if (depth[u] == 0) {
                depth[u] = depth[v] + 1;
                q.push(u);
            }
        }
    }
    while (true) {
        queue<int> q;
        for (int i = 0; i < n; ++i) {
            rt[i] = -1;
            goodedg[i] = -1;
        }
        for (auto i : rdepth[0]) {
            goodedg[i] = 0;
            q.push(i);
        }
        used = 0;
        while (q.size()) {
            int v = q.front();
            q.pop();
            if (used[v])
                continue;
            used[v] = 1;
            for (auto [u, t] : edg[v]) {
                //assert(t >= 0 && goodedg[v] >= 0);
                if (goodedg[u] < goodedg[v] + t) {
                    goodedg[u] = goodedg[v] + t;
                    rt[u] = v;
                    q.push(u);
                }
            }
        }
        //for (int i = 0; i < n; ++i)
            //cout << goodedg[i] << ' ';
        //cout << endl;
        int mxj = -1;
        for (auto j : rdepth[mxdepth]) {
            if (mxj == -1 || goodedg[mxj] < goodedg[j])
                mxj = j;
        }
        if (goodedg[mxj] == 0)
            break;
        int j = mxj;
        ++len[j];
        int ttt = 0;
        while (depth[j]) {
            int i = rt[j];
            for (auto& [u, t] : edg[i]) {
                if (u == j && t) {
                    t = 0;
                    ++ttt;
                }
            }
            j = i;
            ++len[i];
        }
        //cout << ttt << ' ' << goodedg[mxj] << endl;
        //assert(ttt == goodedg[mxj]);
    }
    int w = 0;
    for (auto j : rdepth[0])
        w += len[w];
    cout << mxdepth + 1 << ' ' << w << endl;
    for (int i = 0; i <= mxdepth; ++i) {
        cout << rdepth[i].size() << ' ';
        for (auto j : rdepth[i]) {
            cout << j + 1 << ' ' << len[j] << ' ';
        }
        cout << endl;
    }
}
