#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(v) v.begin(), v.end()
#define trace(x) cout << #x << " = " << x << endl;
#define sz(v) (int) size(v)
#define int ll

const int infI = 1e9 + 7;
const ll infL = 1e18;
const int N = 200001;

vector<int> g[N], g1[N], tops, L[N];
int level[N], in[N], H, added[N], w[N];
bool used[N];

void dfs(int v) {
    used[v] = true;
    for (int to : g[v]) {
        if (!used[to])
            dfs(to);
    }
    tops.push_back(v);
}

void bfs(vector<int> &a) {
    queue<int> d;
    for (int x : a) {
        level[x] = 0;
        d.push(x);
    }
    while (!d.empty()) {
        int v = d.front();
        d.pop();
        H = level[v];
        L[H].push_back(v);
        for (int to : g[v]) {
            if (level[to] == infI) {
                level[to] = level[v] + 1;
                d.push(to);
            }
        }
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g1[v].push_back(u);
        ++in[v];
    }
    vector<int> fl;
    for (int i = 0; i < n; ++i) {
        level[i] = infI;
        if (in[i] == 0)
            fl.push_back(i);
    }
    bfs(fl);
    cout << H + 1 << " ";
    for (int v = 0; v < n; ++v)
        if (!used[v])
            dfs(v);
    reverse(all(tops));
    for (int v : tops) {
        int W = w[v];
        W = max(W, 1ll);
        if (W < g[v].size()) {
            if (!g1[v].empty())
                added[g1[v].front()] += (int) g[v].size() - W;
            W = sz(g[v]);
        }
        w[v] = W;
        for (int to : g[v]) {
            ++w[to];
        }
        if (!g[v].empty()) {
            w[g[v].front()] += W - sz(g[v]);
        }
    }
    reverse(all(tops));
    for (int v : tops) {
        w[v] += added[v];
        if (!g1[v].empty())
            added[g1[v].front()] += added[v];
    }
    int W = 0;
    set<int> st;
    for (int l = 0; l <= H; ++l) {
        int sum = 0;
        for (int v : L[l]) {
            sum += w[v];
        }
        st.insert(sum);
    }
    assert(st.size() == 1);
    W = *st.begin();
    cout << W << '\n';
    for (int l = 0; l <= H; ++l) {
        sort(all(L[l]));
        cout << sz(L[l]) << " ";
        for (int x : L[l])
            cout << x + 1 << " " << w[x] << " ";
        cout << '\n';
    }
    return 0;
}
