#include <iostream>

long long factorial(long long n, long long M, long long startFrom = 2)
{
	long long product = 1;
	for (long long i = startFrom; i <= n; i++) {
		product *= i;
		product %= M;
	}
	return product;
}

long long pretty(long long N, long long n, long long M)
{
	if (n == 0) {
		long long accumulator = 0;
		for (long long i = 1; i < N; i++) {
			accumulator += pretty(N, i, M);
			accumulator %= M;
		}
		return factorial(N, M) - accumulator;
	}

	return pretty(N - n, 0, M) * factorial(N - 1, M, N - n) / factorial(n, M);

}

int main()
{
	std::cin.tie(0); std::cout.tie(0);
	long long N, M;
	std::cin >> N >> M;
	long long accumulator = 0;
	for (long long n = 1; n < N; n++) {
		accumulator += pretty(N, n, M);
		accumulator %= M;
	}

	std::cout << accumulator;

	return 0;
}

//factorial(N - 1) * (N - 1); // Amount of [x, x+1]. But there are intersections.

//countSort.resize(N);
//std::cout << permutate(N, M);
//for (int i = 0; i < N; i++)
//	std::cout << i << ": " << countSort[i] << std::endl;

//
//std::vector<long long> countSort;
//
//long long permutate(long long N, long long M, std::vector<long long> current = {}, std::list<long long> whitelist = {})
//{
//	if (N == 0) {
//		long long count = 0;
//		long long last = current[0];
//		for (auto c : current)
//			std::cout << c;
//		std::cout << "  ";
//		for (long long i = 1; i < current.size(); i++) {
//			if (current[i] == last + 1) {
//				std::cout << "[]";
//				count++;
//			} else 
//				std::cout << "  ";
//			last = current[i];
//		}
//
//		std::cout << "  " << count << std::endl;
//		countSort[count]++;
//		return 0;
//	}
//	long long count = 0;
//
//	if (!whitelist.size())
//		for (long long i = 1; i <= N; i++)
//			whitelist.push_back(i);
//	
//	for (auto i : whitelist) {
//		auto copy = whitelist;
//		copy.remove(i);
//		current.push_back(i);
//		//if (current.size() > 1 && current[current.size() - 1] == current[current.size() - 2] + 1)
//		//	count += factorial(N - 1);
//		//else
//			count += permutate(N - 1, M, current, copy);
//		count %= M;
//		current.pop_back();
//	}
//	return count;
//}